<?php
// ACCESS
define('admincp', true);

// Load WebENGINE
include('../includes/webengine.php');

// Check if user is logged in
if(!isLoggedIn()) { redirect(); }

// Check if user has access
if(!canAccessAdminCP($_SESSION['username'])) { redirect(); }

$admincp_sidebar = array(
	array('News Management',''),
		array('Publish News','addnews'),
		array('Manage News','managenews'),
	array('Account Management',''),
		array('Retrieve Account Information','accountinfo'),
		array('Find Account Characters','accountchars'),
		array('Find Account\'s IP Addresses','accountips'),
		array('Find Accounts from IP','accountsfromip'),
		array('Online Accounts','onlineaccounts'),
	array('Character Management',''),
		array('Edit Character','editcharacter'),
		array('Find Character\'s Account','charsaccount'),
	array('Ban Management',''),
		//array('Ban Account/Character','xxx'),
		//array('Unban Account/Character','xxx'),
		//array('Latest Bans','xxx'),
		//array('Search Bans','xxx'),
		array('Block IP (web)','blockedips'),
	array('Credits Management',''),
		array('Latest PayPal Donations','latestpaypal'),
		array('Latest SuperRewards Donations','latestsr'),
		array('Add Credits','addcredits'),
		array('Substract Credits','substractcredits'),
		array('Top Voters','topvotes'),
		//array('Top Credited Accounts','xxx'),
	array('Modules Management',''),
		array('Modules Manager','modules_manager'),
	array('Plugins Management',''),
		array('Plugins Manager','plugins'),
		array('Import Plugin','plugin_install'),
	array('Cron Jobs Management',''),
		array('Add / Remove Cron Jobs','add_cron'),
);

function enabledisableCheckboxes($name,$checked,$e_txt,$d_txt) {
	echo '<label class="radio">';
	if($checked == 1) {
		echo '<input type="radio" name="'.$name.'" value="1" checked>';
	} else {
		echo '<input type="radio" name="'.$name.'" value="1">';
	}
	echo $e_txt;
	echo '</label>';
	echo '<label class="radio">';
	if($checked == 0) {
		echo '<input type="radio" name="'.$name.'" value="0" checked>';
	} else {
		echo '<input type="radio" name="'.$name.'" value="0">';
	}
	echo $d_txt;
	echo '</label>';
}
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>WebEngine AdminCP</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="WebEngine AdminCP v1.0">
    <meta name="author" content="Lautaro Angelico">

    <!-- Le styles -->
    <link href="css/bootstrap.css" rel="stylesheet">
    <style type="text/css">
	<!--
		body {
			padding-top: 60px;
			padding-bottom: 40px;
		}
		.sidebar-nav {
			padding: 9px 0;
		}
		.module_config_tables tr th {
			width: 40%;
		}
		.module_config_tables tr th span {
			font-weight: normal;
			font-style: italic;
			font-size: 11px;
		}
		.webengine_logo {
			background: url('img/webengine-logo.png') no-repeat center;
			height: 50px;
			margin-bottom: 10px;
		}
		.no-borders, .no-borders tr td, .no-borders tr th {
			border: 0px;
		}
		.small-inputs input {
			padding: 0px !important;
			border-radius: 0px !important;
			margin: 0px !important;
		}
		.character-edit-table {
			width: 600px !important;
		}
	-->
    </style>
    <link href="css/bootstrap-responsive.css" rel="stylesheet">
    <link href="css/bootstrap-fileupload.min.css" rel="stylesheet">
	
	<script src="http://code.jquery.com/jquery.js"></script>
	<script src="js/bootstrap.min.js"></script>
	<script src="js/bootstrap-fileupload.min.js"></script>

    <!-- HTML5 shim, for IE6-8 support of HTML5 elements -->
    <!--[if lt IE 9]>
      <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
  </head>

  <body>

    <div class="navbar navbar-inverse navbar-fixed-top">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </a>
          <!--<a class="brand" href="index.php">WebEngine AdminCP</a>-->
          <div class="nav-collapse collapse">
            <p class="navbar-text pull-right">
              Logged in as <?php echo $_SESSION['username']; ?>, <a href="<?php echo __BASE_URL__.'logout/'; ?>" class="navbar-link">logout</a>
            </p>
            <ul class="nav">
              <li class="active"><a href="index.php">Home</a></li>
              <li><a href="<?php echo __BASE_URL__; ?>" target="_blank">Website Home</a></li>
              <li><a href="http://web.muengine.net/" target="_blank">WebEngine Support</a></li>
            </ul>
          </div><!--/.nav-collapse -->
        </div>
      </div>
    </div>

    <div class="container-fluid">
      <div class="row-fluid">
        <div class="span3">
			<div class="webengine_logo"></div>
          <div class="well sidebar-nav">
			<ul class="nav nav-list">
			<?php
			foreach($admincp_sidebar as $sidebarItem) {
				if(!check_value($sidebarItem[1])) {
					echo '<li class="nav-header">'.$sidebarItem[0].'</li>';
				} else {
					if($_REQUEST['module'] == $sidebarItem[1]) {
						echo '<li class="active"><a href="'.__PATH_ADMINCP_HOME__.'?module='.$sidebarItem[1].'">'.$sidebarItem[0].'</a></li>'; 
					} else {
						echo '<li><a href="'.__PATH_ADMINCP_HOME__.'?module='.$sidebarItem[1].'">'.$sidebarItem[0].'</a></li>'; 
					}
				}
			}
			
			
			if(check_value($extra_admincp_sidebar) && is_array($extra_admincp_sidebar)) {
				echo '<li class="nav-header">Premium Plugins / Modules </li>';
				foreach($extra_admincp_sidebar as $eACPSB) {
				echo '
				<li class="dropdown">
				<a class="dropdown-toggle" data-toggle="dropdown" href="#">'.$eACPSB[0].' <b class="caret"></b></a>
				<ul class="dropdown-menu">';
					foreach($eACPSB[1] as $ddeACPSB) {
						echo '<li><a href="'.__PATH_ADMINCP_HOME__.'?module='.$ddeACPSB[1].'">'.$ddeACPSB[0].'</a></li>';
					}
				echo '
				</ul>
				</li>';
				}
			}
			?>
			</ul>
          </div><!--/.well -->
        </div><!--/span-->
        <div class="span9">
			<?php $handler->loadAdminCPModule($_REQUEST['module']); ?>
        </div><!--/span-->
      </div><!--/row-->

      <hr>

      <footer>
        <p>&copy; Lautaro Angelico 2012 - 2014, WebEngine</p>
      </footer>

    </div>

  </body>
</html>
