<h2>Vote and Reward Settings</h2>
<?php

// Load Vote Class
$vote = new Vote();

function saveChanges() {
	global $_POST;
	foreach($_POST as $setting) {
		if(!check_value($setting)) {
			message('error','Missing data (complete all fields).');
			return;
		}
	}
	$xmlPath = __PATH_MODULE_CONFIGS__.'usercp.vote.xml';
	$xml = simplexml_load_file($xmlPath);
	
	$xml->active = $_POST['setting_1'];
	$xml->vote_save_logs = $_POST['setting_2'];
	$xml->credits_database = $_POST['setting_3'];
	$xml->credits_table = $_POST['setting_4'];
	$xml->credits_column = $_POST['setting_5'];
	$xml->userid_or_username = $_POST['setting_6'];
	$xml->user_identifier_column = $_POST['setting_7'];
	$xml->check_online = $_POST['setting_8'];
	
	$save = $xml->asXML($xmlPath);
	if($save) {
		message('success','Settings successfully saved.');
	} else {
		message('error','There has been an error while saving changes.');
	}
}


if(check_value($_POST['submit_changes'])) {
	saveChanges();
}

if(check_value($_POST['votesite_add_submit'])) {
	$add = $vote->addVotesite($_POST['votesite_add_title'],$_POST['votesite_add_link'],$_POST['votesite_add_reward'],$_POST['votesite_add_time']);
	if($add) {
		message('success','Votesite successfully added.');
	} else {
		message('error','There has been an error while adding the topsite.');
	}
}

if(check_value($_REQUEST['deletesite'])) {
	$delete = $vote->deleteVotesite($_REQUEST['deletesite']);
	if($delete) {
		message('success','Votesite successfully deleted.');
	} else {
		message('error','There has been an error while deleting the topsite.');
	}
}

loadModuleConfigs('usercp.vote');
?>
<form action="index.php?module=modules_manager&config=vote" method="post">
	<table class="table table-striped table-bordered table-hover module_config_tables">
		<tr>
			<th>Status<br/><span>Enable/disable the vote module.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_1',mconfig('active'),'Enabled','Disabled'); ?>
			</td>
		</tr>
		<tr>
			<th>Save Vote Logs<br/><span>If enabled, every vote will be permanently logged in a database table.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_2',mconfig('vote_save_logs'),'Enabled','Disabled'); ?>
			</td>
		</tr>
		<tr>
			<th>Credits Database<br/><span>Define in which database the table with the credits balance is located.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_3',mconfig('credits_database'),'MuOnline','Me_MuOnline'); ?>
			</td>
		</tr>
		<tr>
			<th>Credits Table<br/><span>Define the name of the table in which the credits will be given.</span></th>
			<td>
				<input class="input-small" type="text" name="setting_4" value="<?=mconfig('credits_table')?>"/>
			</td>
		</tr>
		<tr>
			<th>Credits Column<br/><span>Define the column which holds the user's credits information.</span></th>
			<td>
				<input class="input-small" type="text" name="setting_5" value="<?=mconfig('credits_column')?>"/>
			</td>
		</tr>
		<tr>
			<th>Identify user by<br/><span>Choose how the plugin should identify the user.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_6',mconfig('userid_or_username'),'User ID (numeric)','Username (string)'); ?>
			</td>
		</tr>
		<tr>
			<th>User Identifier Column<br/><span>Define the column name containing the user identifier.</span></th>
			<td>
				<input class="input-small" type="text" name="setting_7" value="<?=mconfig('user_identifier_column')?>"/>
			</td>
		</tr>
		<tr>
			<th>Check Online Status<br/><span>It is recommended to keep this enabled to avoid any issues when adding the credits.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_8',mconfig('check_online'),'Enabled','Disabled'); ?>
			</td>
		</tr>
		<tr>
			<td colspan="2"><input type="submit" name="submit_changes" value="Save Changes" class="btn btn-success"/></td>
		</tr>
	</table>
</form>

<hr>
<h3>Manage Vote Sites</h3>
<?php
$votesiteList = $vote->retrieveVotesites();
if(is_array($votesiteList)) {
	echo '<table class="table table-striped table-bordered table-hover module_config_tables">';
	echo '<tr>';
	echo '<th>Title</th>';
	echo '<th>Link (full url including http)</th>';
	echo '<th>Reward</th>';
	echo '<th>Vote Every</th>';
	echo '<th></th>';
	echo '</tr>';
	
	foreach($votesiteList as $thisVoteSite) {
		echo '<tr>';
		echo '<td>'.$thisVoteSite['votesite_title'].'</td>';
		echo '<td>'.$thisVoteSite['votesite_link'].'</td>';
		echo '<td>'.$thisVoteSite['votesite_reward'].' credit(s)</td>';
		echo '<td>'.$thisVoteSite['votesite_time'].' hour(s)</td>';
		echo '<td><a href="index.php?module=modules_manager&config=vote&deletesite='.$thisVoteSite['votesite_id'].'" class="btn btn-block"><i class="icon-remove"></i></a></td>';
		echo '</tr>';
	}
	
	echo '<form action="index.php?module=modules_manager&config=vote" method="post">';
	echo '<tr>';
	echo '<td><input name="votesite_add_title" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_link" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_reward" class="input-mini" type="text"/> credit(s)</td>';
	echo '<td><input name="votesite_add_time" class="input-mini" type="text"/> hour(s)</td>';
	echo '<td><input type="submit" name="votesite_add_submit" class="btn btn-success" value="Add!"/></td>';
	echo '</tr>';
	echo '</form>';
	
	echo '</table>';
} else {
	echo '<h4>Add Voting Site</h4>';
	echo '<table class="table table-striped table-bordered table-hover module_config_tables">';
	echo '<tr>';
	echo '<th>Title</th>';
	echo '<th>Link (full url including http)</th>';
	echo '<th>Reward</th>';
	echo '<th>Vote Every</th>';
	echo '<th></th>';
	echo '</tr>';
	echo '<form action="index.php?module=modules_manager&config=vote" method="post">';
	echo '<tr>';
	echo '<td><input name="votesite_add_title" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_link" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_reward" class="input-mini" type="text"/> credit(s)</td>';
	echo '<td><input name="votesite_add_time" class="input-mini" type="text"/> hour(s)</td>';
	echo '<td><input type="submit" name="votesite_add_submit" class="btn btn-success" value="Add!"/></td>';
	echo '</tr>';
	echo '</form>';
	echo '</table>';
}

?>