<?php

class Handler {

	function loadPage() {
		global $_GET,$_POST,$config,$lang,$dB,$dB2,$_SESSION,$handler,$custom,$common,$_COOKIE,$tSettings;

		if($this->languageExists($config['website_language'])) {
		
			include(__PATH_LANGUAGES__ . $config['website_language'] . '/language.php');
			
			if(!defined('access') or !access) {
				// blank for APIs
			} else {
				if($this->templateExists($config['website_template'])) {
					include(__PATH_TEMPLATES__ . $config['website_template'] . '/index.php');
					if(isLoggedIn() && canAccessAdminCP($_SESSION['username'])) {
						echo '<a href="'.__PATH_ADMINCP_HOME__.'" class="admincp-button">AdminCP</a>';
					}
				} else {
					die('[WEBENGINE::ERROR][!#] Could not load template ' . $config['website_template']);
				}
			}
		} else {
			die('[WEBENGINE::ERROR][!#] Could not load language: ' . $config['website_language']);
		}
	}

	function loadModule($page = 'news',$subpage = 'home') {
		global $_GET,$_POST,$config,$lang,$dB,$dB2,$_SESSION,$custom,$common,$_COOKIE,$mconfig,$tSettings;
		
		$page = $this->cleanRequest($page);
		$subpage = $this->cleanRequest($subpage);
		
		if(!check_value($page)) { $page = 'news'; }
		//if(!check_value($subpage)) { $subpage = 'home'; }
		
		if(!check_value($subpage)) {
			if($this->moduleExists($page)) {
				@loadModuleConfigs($page);
				include(__PATH_MODULES__ . $page . '.php');
			} else {
				$this->module404();
			}
		} else {
			// HANDLE PAGE AS DIRECTORY (PATH)
			switch($page) {
				case 'news':
					if($this->moduleExists($page)) {
						@loadModuleConfigs($page);
						include(__PATH_MODULES__ . $page . '.php');
					} else {
						$this->module404();
					}
				break;
				default:
					$path = $page.'/'.$subpage;
					if($this->moduleExists($path)) {
						$cnf = $page.'.'.$subpage;
						@loadModuleConfigs($cnf);
						include(__PATH_MODULES__ . $path . '.php');
					} else {
						$this->module404();
					}
				break;
			}
		}
	
	}

	function moduleExists($page) {
		if(file_exists(__PATH_MODULES__ . $page . '.php')) {
			return true;
		} else {
			return false;
		}
	}
	
	function usercpmoduleExists($page) {
		if(file_exists(__PATH_MODULES_USERCP__ . $page . '.php')) {
			return true;
		} else {
			return false;
		}
	}
	
	function templateExists($template) {
		if(file_exists(__PATH_TEMPLATES__ . $template . '/index.php')) {
			return true;
		} else {
			return false;
		}
	}
	
	function languageExists($language) {
		if(file_exists(__PATH_LANGUAGES__ . $language . '/language.php')) {
			return true;
		} else {
			return false;
		}
	}
	
	function admincpmoduleExists($page) {
		if(file_exists(__PATH_ADMINCP_MODULES__ . $page . '.php')) {
			return true;
		} else {
			return false;
		}
	}
	
	function isAdminCPModuleRestricted($module,$user) {
		$admincp_modules_restriction = config('admincp_modules_restriction',true);
		if(array_key_exists($module,$admincp_modules_restriction)) {
			$allowed_users = explode(",",$admincp_modules_restriction[$module]);
			if(in_array($user,$allowed_users)) {
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}
	
	function loadAdminCPModule($module='home') {
		global $dB,$dB2,$config,$custom,$_SESSION,$_POST,$_REQUEST,$_GET,$common,$handler,$mconfig,$gconfig;
		if(!check_value($module)) { $module = 'home'; }
		if($this->admincpmoduleExists($module)) {
			if(!$this->isAdminCPModuleRestricted($module,$_SESSION['username'])) {
				include(__PATH_ADMINCP_MODULES__.$module.'.php');
			} else {
				message('error','You do not have access to this module.');
			}
		} else {
			message('error','INVALID MODULE');
		}
	}
	
	function displayTitle() {
		global $_REQUEST,$_GET;
		$page_titles = config('website_page_titles',true);
		$page = $_REQUEST['page'];
		if(check_value($page) && check_value($page_titles[$page])) {
			return '<title>'.config('website_title_alt',true).$page_titles[$page].'</title>';
		} else {
			if(check_value(lang('website_title',true))) {
				return '<title>'.lang('website_title',true).'</title>';
			} else {
				return '<title>'.config('website_title',true).'</title>';
			}
		}
	}
	
	function printHeader() {
		$meta = array(
			'<meta charset="utf-8" />',
			$this->displayTitle(),
			'<meta name="generator" content="WebEngine '.__WEBENGINE_VERSION__.'" />',
			'<meta name="description" content="'.config('website_meta_description',true).'" />',
			'<meta name="keywords" content="'.config('website_meta_keywords',true).'" />',
			'<link rel="shortcut icon" href="'.__PATH_TEMPLATE__.'favicon.ico" />'
		);
		
		return "\n".implode("\n",$meta);
	}
	
	function cleanRequest($string) {
		return preg_replace("/[^a-zA-Z0-9\s\/]/", "", $string);
	}
	
	function module404() {
		if(config('404_redirect',true)) {
			redirect();
		} else {
			if($this->moduleExists('404')) {
				include(__PATH_MODULES__ . '404.php');
			} else {
				redirect();
			}
		}
	}

}

?>