<?php
/* --------------------------------------------------------------------

  WebEngine
  http://web.muengine.net/

  @version	1.0.6
  @author	Lautaro Anglico <http://lautaroangelico.com/>
			<angelico.lautaro@gmail.com>

  Copyright (C) 2012-2014 Lautaro Anglico All rights reserved.

  --------------------------------------------------------------------- */

(!isLoggedIn()) ? redirect(1,'login') : null;

// Load Character Class
$Character = new Character();

echo '
<div class="page-container">
	<div class="page-title">
		<span>'.lang('buyzen_txt_1',true).'</span>
	</div>
	<div class="page-content">';
		
		if(mconfig('active')) {
			$AccountCharacters = $Character->AccountCharacter($_SESSION['username']);
			if(is_array($AccountCharacters)) {
				
				# config file data
				$maxZen = mconfig('max_zen');
				$exchangeRatio = mconfig('exchange_ratio');
				
				# process request
				if(check_value($_POST['submit']) && check_value($_POST['character']) && check_value($_POST['credits'])) {
					try {
						# check if account is online
						if($common->accountOnline($_SESSION['username']))  throw new Exception(lang('error_28',true));
					
						$char = Decode($_POST['character']);
						$zen = $_POST['credits']*$exchangeRatio;
						
						# validate form data
						if(!Validator::UnsignedNumber($_POST['credits'])) throw new Exception(lang('error_25',true));
						if($zen > $maxZen) throw new Exception(lang('error_25',true));
						if(!in_array($char, $AccountCharacters)) throw new Exception(lang('error_24',true));
						
						# gather character information
						$characterData = $Character->CharacterData($char);
						if(!is_array($characterData)) throw new Exception(lang('error_25',true));
						
						# check zen
						$charZen = $characterData[_CLMN_CHR_ZEN_];
						if($charZen+$zen > $maxZen) throw new Exception(lang('error_55',true));
						
						# subtract credits
						if(!$common->substractCredits($_SESSION['userid'], $_POST['credits'])) throw new Exception(lang('error_40',true));
						
						# send zen
						if(!$dB->query("UPDATE "._TBL_CHR_." SET "._CLMN_CHR_ZEN_." = "._CLMN_CHR_ZEN_." + ? WHERE "._CLMN_CHR_NAME_." = ?", array($zen, $characterData[_CLMN_CHR_NAME_])));
						
						message('success', lang('success_21',true));
						message('info', number_format($zen) . lang('buyzen_txt_2',true) . $char);
					} catch(Exception $ex) {
						message('error', $ex->getMessage());
					}
				}
				
				# form
				echo '<form action="" method="post">';
				echo '<table class="general-table-ui" cellspacing="0">';
					echo '<tr>';
						echo '<td>'.lang('buyzen_txt_3',true).'</td>';
						echo '<td>'.lang('buyzen_txt_4',true).'</td>';
						echo '<td></td>';
					echo '</tr>';
					echo '<tr>';
						echo '<td>';
							echo '<select name="character">';
								foreach($AccountCharacters as $char) {
									echo '<option value="'.Encode($char).'">'.$char.'</option>';
								}
							echo '<select>';
						echo '</td>';
						echo '<td>';
							echo '<select name="credits">';
								$zenAmount = $exchangeRatio;
								$creditAmount = 1;
								while($zenAmount <= $maxZen) {
									echo '<option value="'.$creditAmount.'">'.number_format($zenAmount).' - '.$creditAmount.' '.lang('buyzen_txt_6',true).'</option>';
									
									$creditAmount++;
									$zenAmount = $exchangeRatio*$creditAmount;
								}
							echo '</select>';
						echo '<td>';
						echo '<td><button name="submit" value="submit" class="ui-button button1" ><span class="button-left"><span class="button-right">'.lang('buyzen_txt_5',true).'</span></span></button></td>';
					echo '</tr>';
				echo '</table>';
				echo '</form>';
		
			} else {
				message('error', lang('error_46',true));
			}
		} else {
			message('error', lang('error_47',true));
		}
	
echo '	
	</div>
</div>
';
?>